﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace Lrogram
{
    public partial class Form1 : Form
    {
        public Form1(string[] args)
        {
            InitializeComponent();
            this.args = args;
        }

        string[] args;

        private void Form1_Load(object sender, EventArgs e)
        {
            // Zjištění, co se ode mne chce z příkazové řádky
            string cesta = System.Windows.Forms.Application.ExecutablePath;
            string soub = null;
            if (args.Length != 0)
                if (Directory.Exists(args[0]))
                    cesta = args[0];
                else if (File.Exists(args[0]) && (new FileInfo(args[0]).Extension == ".jpg" || new FileInfo(args[0]).Extension == ".jpeg"))
                {
                    cesta = new FileInfo(args[0]).DirectoryName;
                    soub = args[0];
                }
                else
                    MessageBox.Show("Jako argument při volání tohoto programu prosím volte pouze platné názvy souborů nebo adresářů, děkuji.");

            TreeNode tN = treeView1.Nodes.Add("Tento počítač");
            tN.Tag = "null";

            // Vypsání logických jednotek na počítači do stromu
            foreach (string jednotka in Environment.GetLogicalDrives())
            {
                TreeNode tn = tN.Nodes.Add(jednotka);
                tn.Tag = jednotka;
                tn.Nodes.Add("plchldr");
            }

            // Rozbalení struktury tam, kde jsem nebo kam bylo žádáno
            tN.Expand();

            TreeNode tnP = null;
            foreach (TreeNode tn in tN.Nodes)
                if (tn.Text.StartsWith(cesta.ToUpper()[0].ToString()))
                    (tnP = tn).Expand();

            cesta = cesta.Replace('/', '\\');
                     
            foreach (string kus in cesta.Split('\\'))
                foreach (TreeNode tn in tnP.Nodes)
                    if (tn.Text == kus)
                    {
                        (tN = tn).Expand();
                        break;
                    }

            if (soub != null)
            {
                Form2 f2 = new Form2(soub, false);
                f2.ShowDialog();
            }
        }

        string aktAdresář = "null";

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Node.Tag == "null") return;
            e.Node.Nodes.Clear();
            foreach (DirectoryInfo di in new DirectoryInfo(e.Node.Tag.ToString()).GetDirectories())
            {
                TreeNode tn = e.Node.Nodes.Add(di.Name);
                tn.Tag = di.FullName;
                tn.Nodes.Add("plchldr");
            }
        }

        string aPrvního = "";

        List<FileInfo> obrss = new List<FileInfo>();

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (e.Node.Tag == "null") return;
            DirectoryInfo dI = new DirectoryInfo(aktAdresář = e.Node.Tag.ToString());
            List<FileInfo> obrs = new List<FileInfo>();
            obrs.AddRange(dI.GetFiles("*.jpg"));
            obrs.AddRange(dI.GetFiles("*.jpeg"));
            obrs.Sort((FileInfo fi1, FileInfo fi2) => fi1.Name.CompareTo(fi2.Name));
            obrss = obrs;

            int top = 10;
            int genNaZač = 4; int count = 0;
            foreach (FileInfo fi in obrs)
            {
                // Zobrazování náhledového obrázku
                PictureBox pb = new PictureBox();
                pb.Top = top;
                pb.Left = 10;
                pb.Click += new EventHandler(pb_Click); // Reakce na kliknutí
                pb.MouseMove += new MouseEventHandler(pb_MouseMove); // Reakce na najetí
                pb.MouseLeave += new EventHandler(pb_MouseLeave); // Reakce na odjetí
                pb.Width = 133;
                pb.Height = 100;
                // Generování několika prvních mála náhledů, ostatní se buď vyberou z keše,
                // nebo se zatím místo nich dosadí neutrální obrázek, který se nahradí až
                // se dogeneruje na pozadí
                Image náhled = dejNáhled(fi.FullName, (count++ > genNaZač ? false : true));
                pb.Tag = fi.FullName;
                pb.Image = náhled;
                pb.SizeMode = PictureBoxSizeMode.Zoom;
                panel1.Controls.Add(pb);

                // Generování popisků
                Label lblNázev = new Label();
                lblNázev.Font = new Font(FontFamily.GenericSansSerif, 16);
                lblNázev.Text = fi.Name;
                lblNázev.Top = top + 10;
                lblNázev.Left = 150;
                lblNázev.Width = 200;
                lblNázev.Height = 30;
                panel1.Controls.Add(lblNázev);

                Label lblPodr = new Label();
                lblPodr.Font = new Font(FontFamily.GenericSansSerif, 12);
                lblPodr.Text = "Velikost: " + (fi.Length / (1024.0 * 1024)).ToString("F3") + " MiB" + "\r\nRozměry: ? x ? px\r\nDatum: " + fi.CreationTime.ToString("d. MMMM yyyy, HH:mm:ss");
                lblPodr.Top = top + 40;
                lblPodr.Left = 160;
                lblPodr.Width = 280;
                lblPodr.Height = 60;
                panel1.Controls.Add(lblPodr);

                top += 120;
            }

            progressBar1.Visible = true;
            progressBar1.Value = 0;

            // Náhledy generuji na pozadí tady
            bw = new BackgroundWorker();
            bw.WorkerReportsProgress = true;
            bw.DoWork += new DoWorkEventHandler(bw_DoWork);
            bw.ProgressChanged += new ProgressChangedEventHandler(bw_ProgressChanged);
            bw.RunWorkerCompleted +=new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
            bw.RunWorkerAsync(dI.FullName);
        }        

        // Dokončení generování náhledů
        void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            progressBar1.Visible = false;
            foreach (Control c in panel1.Controls)
                if (c is PictureBox)
                    ((PictureBox)c).Image = dejNáhled(c.Tag.ToString(), false);
        }

        // Pracovní metoda mi poslala zprávu, že je zase o kousek dál
        void bw_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progressBar1.Value = e.ProgressPercentage;
        }

        BackgroundWorker bw;

        // Vlastní pracovní procedura, která na pozadí generuje náhledy
        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            DirectoryInfo dI = new DirectoryInfo(e.Argument.ToString());

            List<FileInfo> obrs = new List<FileInfo>();
            obrs.AddRange(dI.GetFiles("*.jpg"));
            obrs.AddRange(dI.GetFiles("*.jpeg"));
            obrs.Sort((FileInfo fi1, FileInfo fi2) => fi1.Name.CompareTo(fi2.Name));

            int i = 0;
            foreach (FileInfo fi in obrs)
            {
                dejNáhled(fi.FullName, true);
                if (i % 10 == 0)
                    bw.ReportProgress(i * 100 / obrs.Count, fi.FullName);
                i++;
            }
        }

        // "zbělení" obrázku při najetí myší
        void pb_MouseLeave(object sender, EventArgs e)
        {
            ((PictureBox)sender).Image = dejNáhled(((PictureBox)sender).Tag.ToString(), true);
        }

        // a "odbělení" při odjetí
        void pb_MouseMove(object sender, MouseEventArgs e)
        {
            ((PictureBox)sender).Image = zesvětli(dejNáhled(((PictureBox)sender).Tag.ToString(), true));
        }

        Image zesvětli(Image co)
        {
            Bitmap B = new Bitmap(co);
            for (int x = 0; x < co.Width; x++)
                for (int y = 0; y < co.Height; y++)
                    B.SetPixel(x, y, ZesvětliPixel(B.GetPixel(x, y)));
            return B;
        }

        Color ZesvětliPixel(Color c)
        {
            return Color.FromArgb((c.R + 255) / 2, (c.G + 255) / 2, (c.B + 255) / 2);
        }

        Image hsl = Image.FromFile("hsl.png");

        Image dejNáhled(string cesta, bool opravduGeneruj)
        { // Pokud naplatí opravduGeneruj, vrátí metoda místo náhledu dočasný obrázek,
            // který tam bude dokud nebude nahrazen skutečnou zmenšeninou
            if (!Directory.Exists("cache"))
                Directory.CreateDirectory("cache");

            if (File.Exists("cache/" + heš(cesta)))
                return Image.FromFile("cache/" + heš(cesta));

            if (opravduGeneruj)
            {
                Bitmap B = new Bitmap(133, 100);
                Graphics G = Graphics.FromImage(B);
                G.DrawImage(Image.FromFile(cesta), new Rectangle(0, 0, 133, 100));
                B.Save("cache/" + heš(cesta));
                return B;
            }

            return hsl;
        }

        string heš(string co)
        {
            MD5CryptoServiceProvider x = new MD5CryptoServiceProvider();
            byte[] data = Encoding.ASCII.GetBytes(co);
            data = x.ComputeHash(data);
            string ret = "";
            for (int i = 0; i < data.Length; i++)
                ret += data[i].ToString("x2").ToLower();
            return ret;
        }

        void pb_Click(object sender, EventArgs e)
        {
            Form2 f2 = new Form2(((PictureBox)sender).Tag.ToString(), false);
            f2.ShowDialog();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Escape)
                this.Close();
            else if (e.KeyData == Keys.E)
                button1_Click(null, null);
            else if (e.KeyData == Keys.S)
                button2_Click(null, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (obrss.Count == 0)
            {
                MessageBox.Show("Musíte zvolit adresář, ve kterém jsou nějaké obrázky.");
                return;
            }

            folderBrowserDialog1.ShowNewFolderButton = true;
            folderBrowserDialog1.ShowDialog();
            if (folderBrowserDialog1.SelectedPath == "")
                return;
            DirectoryInfo adr = new DirectoryInfo(folderBrowserDialog1.SelectedPath);

            StringBuilder SB = new StringBuilder(10000); // Sem budu generovat HTML.
            SB.Append("<!DOCTYPE html>"); // Hleďte, jak jsem moderní!
            SB.Append("<title>" + adr.Name + "</title>");
            SB.Append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
            SB.Append("<style>img {border-width:0}</style>");
            SB.Append("<h1>" + adr.Name + "</h1>");
            SB.Append("<table>"); // Sem radši moc nekoukejte.

            List<FileInfo> obrs = new List<FileInfo>();
            obrs.AddRange(new DirectoryInfo(aktAdresář).GetFiles("*.jpg"));
            obrs.AddRange(new DirectoryInfo(aktAdresář).GetFiles("*.jpeg"));
            obrs.Sort((FileInfo fi1, FileInfo fi2) => fi1.Name.CompareTo(fi2.Name));

            foreach (FileInfo fi in obrs)
            {
                SB.Append("<tr>");
                SB.Append("<td><a href='" + heš(fi.FullName) + ".jpg'><img src='thumb-" + heš(fi.FullName) + ".jpg' width='133' height='100' alt='" + fi.Name + "'></a>");
                    // Zsoft a. s.: Dáváme nový význam výrazu "cool URIs".
                SB.Append("<td><big>" + fi.Name + "</big><br>Velikost: " + (fi.Length / (1024.0 * 1024)).ToString("F3") + " MiB");
                SB.Append("<br>Datum pořízení: " + fi.CreationTime.ToString("d. MMMM yyyy, HH:mm:ss"));
            }

            SB.Append("</table>");
            using (StreamWriter SW = new StreamWriter(adr.FullName + "/index.html"))
                SW.Write(SB.ToString());

            foreach (FileInfo fi in obrs)
            {
                dejNáhled(fi.FullName, true).Save(adr.FullName + "/thumb-" + heš(fi.FullName) + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                File.Copy(fi.FullName, adr.FullName + "/" + heš(fi.FullName) + ".jpg");
            }

            MessageBox.Show("Dokonáno. Zkusím teď otevřít prohlížeč a ukázat vám výsledek.");

            try
            {
                System.Diagnostics.Process.Start("iexplore", adr + "/index.html");
            }
            catch { }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (obrss.Count == 0)
            {
                MessageBox.Show("Musíte zvolit adresář, ve kterém jsou nějaké obrázky.");
                return;
            }
            Form2 f2 = new Form2(obrss[0].FullName, true);
            f2.ShowDialog();
        }

        // Nefunguje mi bublání událostí. Takže přeposílám "ručně":
        #region bublifuk
        private void treeView1_KeyDown(object sender, KeyEventArgs e)
        {
            Form1_KeyDown(sender, e);
        }

        private void button1_KeyDown(object sender, KeyEventArgs e)
        {
            Form1_KeyDown(sender, e);
        }

        private void button2_KeyDown(object sender, KeyEventArgs e)
        {
            Form1_KeyDown(sender, e);
        }

        private void splitContainer1_KeyDown(object sender, KeyEventArgs e)
        {
            Form1_KeyDown(sender, e);
        }

        private void splitContainer2_KeyDown(object sender, KeyEventArgs e)
        {
            Form1_KeyDown(sender, e);
        }
        #endregion
    }
}
