﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Lrogram
{
    public partial class Form2 : Form
    {
        public Form2(string cesta, bool slideshow)
        {
            InitializeComponent();

            aktCesta = cesta;

            přenosSlideshow = slideshow;
        }
        bool přenosSlideshow;
        string aktCesta = "";
        List<FileInfo> obrs = new List<FileInfo>();
        int curI = -1;

        private void Form2_Load(object sender, EventArgs e)
        {
            pictureBox1.Image = Image.FromFile(aktCesta);
            this.Text = System.IO.Path.GetFileNameWithoutExtension(aktCesta);

            obrs.AddRange(new FileInfo(aktCesta).Directory.GetFiles("*.jpg"));
            obrs.AddRange(new FileInfo(aktCesta).Directory.GetFiles("*.jpeg"));
            obrs.Sort((FileInfo fi1, FileInfo fi2) => fi1.Name.CompareTo(fi2.Name));

            int i = 0;
            foreach (FileInfo fi in obrs)
            {
                if (fi.FullName == aktCesta)
                {
                    curI = i;
                    break;
                }
                i++;
            }

            if (přenosSlideshow)
                button6_Click(null, null);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = ZČBobr(pictureBox1.Image);
            uložit();
        }

        Image ZČBobr(Image obr)
        {
            Bitmap B = new Bitmap(obr);
            for (int x = 0; x < obr.Width; x++)
                for (int y = 0; y < obr.Height; y++)
                    B.SetPixel(x, y, ZČB(B.GetPixel(x, y)));
            return B;
        }

        private Color ZČB(Color v)
        {
            int p = (v.R + v.G + v.B)/3;
            return Color.FromArgb(p, p, p);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            button7.Enabled = !button7.Enabled;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = HorObrObr(pictureBox1.Image);
            uložit();
        }

        Image HorObrObr(Image obr)
        {
            Bitmap B = new Bitmap(obr);
            for (int x = 0; x < obr.Width; x++)
                for (int y = 0; y < obr.Height / 2; y++)
                {
                    Color swap = B.GetPixel(x, y);
                    B.SetPixel(x, y, B.GetPixel(x, obr.Height - 1 - y));
                    B.SetPixel(x, obr.Height - 1 - y, swap);
                }
            return B;
        }

        private void uložit()
        {
            try
            {
                pictureBox1.Image.Save(aktCesta, System.Drawing.Imaging.ImageFormat.Jpeg);
            }
            catch { }
            MessageBox.Show("OK.");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = VerObrObr(pictureBox1.Image);
            uložit();
        }

        Image VerObrObr(Image obr)
        {
            Bitmap B = new Bitmap(obr);
            for (int x = 0; x < obr.Width / 2; x++)
                for (int y = 0; y < obr.Height; y++)
                {
                    Color swap = B.GetPixel(x, y);
                    B.SetPixel(x, y, B.GetPixel(obr.Width - 1 - x, y));
                    B.SetPixel(obr.Width - 1 - x, y, swap);
                }
            return B;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = DolOtoObr(pictureBox1.Image);
            uložit();
        }

        Image DolOtoObr(Image obr)
        {
            Bitmap zdroj = (Bitmap)obr;
            Bitmap B = new Bitmap(obr.Height, obr.Width);
            for (int x = 0; x < obr.Width; x++)
                for (int y = 0; y < obr.Height; y++)
                    B.SetPixel(y, obr.Width - 1 - x, zdroj.GetPixel(x, y));
            return B;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = DopOtoObr(pictureBox1.Image);
            uložit();
        }

        Image DopOtoObr(Image obr)
        {
            Bitmap zdroj = (Bitmap)obr;
            Bitmap B = new Bitmap(obr.Height, obr.Width);
            for (int x = 0; x < obr.Width; x++)
                for (int y = 0; y < obr.Height; y++)
                    B.SetPixel(obr.Height - 1 - y, x, zdroj.GetPixel(x, y));
            return B;
        }

        private void Form2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Home)
                button8_Click(null, null);
            else if (e.KeyData == Keys.PageUp)
                button10_Click(null, null);
            else if (e.KeyData == Keys.PageDown)
                button9_Click(null, null);
            else if (e.KeyData == Keys.End)
                button11_Click(null, null);
            else if (e.KeyData == Keys.S)
                button6_Click(null, null);
            else if (e.KeyData == Keys.H)
                button1_Click(null, null);
            else if (e.KeyData == Keys.V)
                button2_Click(null, null);
            else if (e.KeyData == Keys.L)
                button3_Click(null, null);
            else if (e.KeyData == Keys.R)
                button4_Click(null, null);
            else if (e.KeyData == Keys.G)
                button5_Click(null, null);
            else if (e.KeyData == Keys.Escape && slideshow)
            {
                button6.Enabled = true;
                slideshow = false;
            }
            else if (e.KeyData == Keys.Escape)
                this.Close();
            else if (e.KeyData == Keys.Add)
                button14_Click(null, null);
            else if (e.KeyData == Keys.Divide)
                button13_Click(null, null);
            
        }

        // přednačítání
        Image první = null, poslední = null, další = null, předchozí = null;

        bool slideshow = false;

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (slideshow)
            {
                button10_Click(null, null);
                if (curI == obrs.Count - 1)
                {
                    slideshow = false;
                    button6.Enabled = true;
                }
            }

            if (první == null)
            {
                první = Image.FromFile(obrs[0].FullName);
                return;
            }

            if (poslední == null)
            {
                poslední = Image.FromFile(obrs[obrs.Count - 1].FullName);
                return;
            }

            if (další == null && curI != obrs.Count - 1)
            {
                další = Image.FromFile(obrs[curI + 1].FullName);
                return;
            }

            if (předchozí == null && curI != 0)
            {
                předchozí = Image.FromFile(obrs[curI - 1].FullName);
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (curI == 0) return;
            curI--;
            if (předchozí != null) pictureBox1.Image = předchozí;
            else pictureBox1.Image = Image.FromFile(obrs[curI].FullName);
            aktCesta = obrs[curI].FullName;
            předchozí = null;
            další = null;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (curI == obrs.Count - 1) return;
            curI++;
            if (další != null) pictureBox1.Image = další;
            else pictureBox1.Image = Image.FromFile(obrs[curI].FullName);
            aktCesta = obrs[curI].FullName;
            předchozí = null;
            další = null;
            this.Text = obrs[curI].Name;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            curI = obrs.Count - 1;
            if (poslední != null) pictureBox1.Image = poslední;
            else pictureBox1.Image = Image.FromFile(obrs[curI].FullName);
            aktCesta = obrs[curI].FullName;
            předchozí = null;
            další = null;
            this.Text = obrs[curI].Name;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            curI = 0;
            if (první != null) pictureBox1.Image = první;
            else pictureBox1.Image = Image.FromFile(obrs[curI].FullName);
            aktCesta = obrs[curI].FullName;
            předchozí = null;
            další = null;
            this.Text = obrs[curI].Name;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Promítání přerušíte stiskem klávesy Escape (levý horní roh klávesnice).");
            button6.Enabled = false;
            slideshow = true;
            button8_Click(null, null);
        }

        // Nefunguje mi bublání událostí. Takže přeposílám "ručně":
        #region bublifuk
        private void splitContainer1_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button8_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button9_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button10_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button11_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button6_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button1_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button2_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button3_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button4_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }

        private void button5_KeyDown(object sender, KeyEventArgs e)
        {
            Form2_KeyDown(sender, e);
        }
        #endregion

        private void button12_Click(object sender, EventArgs e)
        {
            pictureBox1.SizeMode = PictureBoxSizeMode.CenterImage;
            pictureBox1.Refresh();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
            pictureBox1.Refresh();
        }

        private void button14_Click(object sender, EventArgs e)
        {
            panel1.Width = (int)(panel1.Width * 1.5);
            panel1.Height = (int)(panel1.Height * 1.5);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            uložit();
        }
    }
}
